﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;

// For more information on enabling Web API for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace ApiLol.Controllers
{
    [Route("api/[controller]")]
    public class ChampionController : ControllerBase
    {
        private readonly ILogger<ChampionController> _logger;

        public ChampionController(ILogger<ChampionController> logger)
        {
            _logger = logger;
        }


        // GET: api/champion
        [HttpGet]
        public ActionResult<IEnumerable<ChampionDTO>> Get()
        {
            List<ChampionDTO> champions = new List<ChampionDTO>();
            champions.Add(new ChampionDTO
            {
                Id = 1,
                Name = "Aurel",
                Bio = "Trop joli",
                Icon = "Moi"
            });
            champions.Add(new ChampionDTO
            {
                Id = 2,
                Name = "Mathilde",
                Bio = "Elle est reloue",
                Icon = "Macheval"
            });
            return Ok(champions);
        }

        // GET api/values/5
        [HttpGet("{id}")]
        public ActionResult<ChampionDTO?> Get(int id)
        {
            List<ChampionDTO> champions = new List<ChampionDTO>();
            champions.Add(new ChampionDTO
            {
                Id = 1,
                Name = "Aurel",
                Bio = "Trop joli",
                Icon = "Moi"
            });
            champions.Add(new ChampionDTO
            {
                Id = 2,
                Name = "Mathilde",
                Bio = "Elle est reloue",
                Icon = "Macheval"
            });

            ChampionDTO? champion = champions.SingleOrDefault((ChampionDTO arg) => arg.Id == id);
            if (champion == null)
            {
                return BadRequest();
            }
            return Ok(champion);
        }

        // POST api/values
        [HttpPost]
        public void Post([FromBody]int id, string name, string bio, string icon)
        {
            if (string.IsNullOrWhiteSpace(name) || string.IsNullOrWhiteSpace(bio) || string.IsNullOrWhiteSpace(icon)){
                BadRequest();
            }
            else
            {
                Ok();
            }
        }

        // PUT api/values/5
        [HttpPut("{id}")]
        public void Put(int id, [FromBody]string value)
        {
        }

        // DELETE api/values/5
        [HttpDelete("{id}")]
        public void Delete(int id)
        {
        }
    }
}

